/* ---------------------- blink.c ---------------------------

   Das "Hallo Welt" der Microcontroller: Blinkende LED

   17.09.2015 R. Seelig
   ---------------------------------------------------------- */


#include <util/delay.h>
#include <avr/io.h>


#include "avr_gpio.h"

// PB5 ist die Onboard-LED auf einem Arduino UNO

#define led_init()     PB5_output_init()
#define led_clr()      PB5_set()
#define led_set()      PB5_clr()

#define delay          _delay_ms

#define blkspeed_high  500
#define blkspeed_low   50

int main(void)
{

  led_init();

  while(1)
  {
    led_set();
    delay(blkspeed_high);
    led_clr();
    delay(blkspeed_low);
  }
}
