/* -----------------------------------------------------
                           ir_demo.c

     Versuche mit dem HX1838 IR-Receiver

     MCU   : ATmegaxx8
     F_CPU : 8 MHz intern

     10.05.2021        R. Seelig

  ------------------------------------------------------ */

#include "my_printf.h"
#include "hx1838_tim1.h"
#include "uart_all.h"


#define printf     my_printf


/* --------------------------------------------------
                       my_putchar

     wird zwingend "cp1_printf.cpp" benoetigt!
     Ueber diese Funktion erfolgen die Ausgaben von
     printf
   -------------------------------------------------- */
void my_putchar(char ch)
{
  uart_putchar(ch);
}

/* --------------------------------------------------------
                             main
   -------------------------------------------------------- */
int main(void)
{
  uint8_t count;
  uint8_t ch;

  uart_init();
  hx1838_init();

  printf("\n\n\rIR-Empfaenger\n\n\r");

  printf(" IR-Code: %x", ir_code);
  ir_newflag= 0;
  while(1)
  {
    if (ir_newflag)
    {
      printf("\r IR-Code: %x", ir_code);
      ir_newflag= 0;
    }
  }
}

