/* -------------------------------------------------------
                      avr_rtc.h

     Softwareuhr, realisiert mittels Timer2 der durch
     einen 32,768 kHz Uhrenquartz getaktet ist

     MCU   :  ATMegaxx8
     Takt  :  Coretakt 8 MHz intern
              RTC-Takt 32,768 kHz Uhrenquarz

     Hinweis:

     Der Quarz wird wie ein "normaler" Quarz an die
     Anschluesse XTAL1, XTAL2 angeschlossen. Zieh-
     kondensatoren sollten im Bereich von 22pf bis 27pF
     liegen.

     Nach dem Start der Firmware kann es bis zu 7
     Sekunden dauern, bis der Taktgeber angeschwungen ist.

     04.05.2021  R. Seelig
   ------------------------------------------------------ */

#ifndef in_avr_rtc
  #define in_avr_rtc

  #include <avr/io.h>
  #include <avr/interrupt.h>

  extern volatile uint8_t   std, min, sek, hsek;
  extern volatile uint8_t   day, month;
  extern volatile int       year;

  void timer2_init(void);
  char getwtag(int day, int month, int year);

#endif
