/* -----------------------------------------------------
                        hx1838_tim1.h

     Header fuer den Betrieb eines HX1838 IR-Receiver

     Modul verwendet Timer1

     MCU   : ATmegaxx8
     F_CPU : 8 MHz intern

     10.05.2021        R. Seelig
  ------------------------------------------------------ */

#ifndef in_hx1838_tim1
  #define in_hx1838_tim1

  #include <avr/io.h>
  #include <avr/interrupt.h>

  #include "avr_gpio.h"

  enum { pscale1 = 1, pscale8, pscale64, pscale256,  pscale1024 };

  extern volatile uint16_t  ir_code;                        // Code des letzten eingegangenen 16-Bit Wertes
  extern volatile uint8_t   ir_newflag;                     // zeigt an, ob ein neuer Wert eingegangen ist

  // PB1 als IR-Data-Input (PCINT1)
  #define ir_input_init()    { PB1_input_init(); PB1_set(); }
  #define is_irin()          is_PB1()

  #define IR_ISR_vect        PCINT0_vect
  #define IR_PCINT           PCINT1
  #define IR_PCMSK           PCMSK0
  #define IR_PCIE            PCIE0

  #define tim1_getvalue()    TCNT1
  #define tim1_clr()         TCNT1= 0;

/* -------------------------------------------------
                        Prototyp
   ------------------------------------------------- */

  void hx1838_init(void);


#endif
