/* -------------------------------------------------------
                         i2c_mega.h

     Header zur Benutzung des I2C Buses

     MCU   :  ATmega8, ATmega48 .. ATmega328p
     Takt  :

     07.05.2019  R. Seelig
   ------------------------------------------------------ */

#ifndef in_mega_i2c
  #define in_mega_i2c

  #include <util/twi.h>

  void i2c_init(void);
  void i2c_stop(void);
  uint8_t i2c_startaddr(uint8_t addr, uint8_t rwflag);
  uint8_t i2c_write(uint8_t value);
  void i2c_write16(uint16_t value);
  uint8_t i2c_read(void);
  uint8_t i2c_read_nack(void);

//  #define F_SCL 50000ul                                      // Taktfrequenz (kleinerer Wert = langsamer)
  #define F_SCL 150000ul                                       // Taktfrequenz (kleinerer Wert = langsamer)
  #define Prescaler 1
  #define TWBR_val ((((F_CPU / F_SCL) / Prescaler) - 16 ) / 2)

#endif
