/* --------------------------- my_printf.h  ----------------------------

     Implementierung einer sehr minimalistischen (und im Funktionsumfang
     eingeschraenkten) Version von printf, jedoch (im Gegensatz zu
     my_printf.c) mit Ausgabe fuer 32-Bit Integer.

     Benoetigt "irgendwo" im Gesamtprogram ein

                my_putchar(char c);


     28.12.2017   R. Seelig

     Danke an www.mikrocontroller.net (Dr.Sommer, beric)

   --------------------------------------------------------------------- */

#ifndef in_myprintf32
  #define in_myprintf32

  #include <avr/io.h>
  #include <avr/pgmspace.h>
  #include <stdarg.h>

  extern char printfkomma;

  extern void my_putchar(char c);
  void putint(int32_t i, char komma);
  void hexnibbleout(uint8_t b);
  void puthex(uint16_t h, char out16);
  void my_putstring(uint8_t *p);

  void own_printf(const uint8_t *s,...);

  #define tiny_printf(str,...)  (own_printf(PSTR(str), ## __VA_ARGS__))
  #define my_printf             tiny_printf


#endif


