/* -----------------------------------------------------------
                         dot8x8_4digdemo.c

   Demoprogramm zur 4-fach kaskadierten 8x8 Leuchtdiodenmatrix
   mit MAX7219

   Benoetigte Hardware;

            - 4 Sueck 8x8 LED Matrix mit MAX7219 IC

   MCU   :  alle AVR
   Takt  :  intern oder extern


   23.03.2022 by R. Seelig
   ----------------------------------------------------------- */

#include <util/delay.h>
#include <avr/io.h>
#include <avr/pgmspace.h>

#include "max7219_dot8x8_4.h"
#include "avr_gpio.h"
#include "my_printf.h"


/* --------------------------------------------------------
   my_putchar

   wird von my-printf / printf aufgerufen
   -------------------------------------------------------- */
void my_putchar(char ch)
{
  fb_putchar(aktxp, aktyp, ch);
  aktxp+= fontsizex;
}

/* -----------------------------------------------------------
                             main
   ----------------------------------------------------------- */
int main(void)
{
  int8_t i;
  int pz;

  m7219_init4();
  m7219_clrscr();


  while(1)
  {
    setfont(0);

    m7219_tx_scrollin(60, &("Hallo"));
    delay(1000);
    fb_clr();
    m7219_tx_scrollin(60, &("Welt"));
    delay(1000);

    printfkomma= 1;
    for (pz= 0; pz < 1000; pz++)
    {
      setfont(0);
      gotoxy(0,0);
      if (pz< 100) { printf("0"); }
      if (pz< 10) { printf("0"); }
      printf("%k", pz);
      setfont(1);
      gotoxy(24,0);
      my_putchar(131);            // Prozentzeichen ausgeben
      m7219_setfb();
      delay(40);
    }
    delay(1500);
  }

}

