/* ---------------------------------------------------------------------
                                 my_printf32.h

     Implementierung einer sehr minimalistischen (und im Funktionsumfang
     eingeschraenkten) Version von printf, jedoch (im Gegensatz zu
     my_printf.c) mit Ausgabe fuer 32-Bit Integer.

     Benoetigt "irgendwo" im Gesamtprogram ein

                my_putchar(char c);


     29.03.2024   R. Seelig

     Danke an www.mikrocontroller.net (Dr.Sommer, beric) fuer deren
     Hilfestellung

   --------------------------------------------------------------------- */

#ifndef in_myprintf32
  #define in_myprintf32

  #include <avr/pgmspace.h>
  #include <stdarg.h>

  #define printf_enable       1
  #define sprintf_enable      1

  enum { MYSTREAM, MYARRAY };

  extern char printfkomma;

  extern void my_putchar(char c);
  void putint(int32_t i, char komma);
  void hexnibbleout(uint8_t b);
  void puthex(uint16_t h, char out16);
  void my_putramstring(char *p);

  #if (printf_enable == 1)
    void own_printf(const uint8_t *s,...);

    #define tiny_printf(str,...)  (own_printf(PSTR(str), ## __VA_ARGS__))
    #define my_printf             tiny_printf
  #endif

  #if (sprintf_enable == 1)
    void own_sprintf(char *buffer, const uint8_t *s,...);

    #define tiny_sprintf(buffer, str,...)  (own_sprintf(buffer, PSTR(str), ## __VA_ARGS__))
    #define my_sprintf             tiny_sprintf
  #endif

#endif


