/* ---------------------------------------------------------------
                          my_printf_demo.c

     Demoprogramm fuer my_printf / my_sprintf mit Ausgabe ueber
     eine serielle Schnittstelle

     MCU : AVR-Mikrocontroller mit Flashspeicher > 2kByte
     Takt: beliebig

     29.03.2024   R. Seelig
   -------------------------------------------------------------- */

#include <avr/io.h>
#include <string.h>

#include "my_printf.h"
#include "uart_all.h"


#define printf    my_printf             // printf auf eigene Funktionen "umleiten"
#define sprintf   my_sprintf            // dto. fuer sprintf

#define delay     _delay_ms


/* --------------------------------------------------------
   my_putchar

   wird von my-printf / printf aufgerufen und hier muss
   eine Zeichenausgabefunktion angegeben sein, auf das
   printf dann schreibt !
   -------------------------------------------------------- */
void my_putchar(char ch)
{
  uart_putchar(ch);
}

/* --------------------------------------------------
                       putstr

     gibt einen Ascii-Z String aus
   -------------------------------------------------- */
void putstr(char *p)
{
  while(*p)
  {
    my_putchar( *p );
    p++;
  }
}



/* --------------------------------------------------------
                             main
   -------------------------------------------------------- */
int main(void)
{
  char    txtbuffer[50];
  uint8_t counter;

  uint8_t z;
  int     a,a2, b,c;

  uart_init();

  printf("\n\n\rDemo fuer 'my_printf.c'");
  printf("  \n\r-------------------------------------\n\r");

  a= 42; b= 13;
  a2= a*100;                        // a um 2 dezimale Stellen nach links verschieben
                                    // um dann mittels %k Platzhalter 2 Nachkommastellen
                                    // anzeigen zu koennen
  printfkomma= 2;                   // 2 Kommastellen fuer %k my_printf

  z= 74;
  printf("\n\rPseudokomma: %d / %d = %k", a,b, a2/b);
  printf("\n\rZahlenwert %d entspricht: %ddez, 0x%x, Ascii-Zeichen '%c'",z,z,z,z);

  sprintf(txtbuffer, "\n\n\rAusgabe ueber 'sprintf': %d * %d = %d", a, b, a*b);
  putstr(txtbuffer);

  printf("\n\n\r");
  counter= 0;

  while(1)
  {
    printf("    counter= %d \r",counter);
    counter++;
    delay(1000);
  }
}
