#include <avr/io.h>

//----------------------------------------------------------------
//   per copy & paste meiner eigenen atm_timers.h
//   und das was zu Timer2 gehoert

#define tim2_fastpwm_enable   1
#define tim2_normalmode_init  1

#define tim2_divisor1         1
#define tim2_divisor8         2
#define tim2_divisor32        3
#define tim2_divisor64        4
#define tim2_divisor128       5
#define tim2_divisor256       6
#define tim2_divisor1024      7

//----------------------------------------------------------------
//   per copy & paste meiner eigenen atm_timers.h
//   und das was zu Timer2 gehoert

#if (tim2_fastpwm_enable == 1)

  void tim2_fastpwm_init(uint8_t clockdivider, uint8_t t_periode, uint8_t t_pulse)
  {
    // tim2 = fast-pwm, compare match b, output auf pd3
    
    // PD3 als Ausgang
    DDRD |= 1 << PD3;
    
    // Timermode und Divider
    TCCR2A = (1 << COM2B1) | (1 << WGM21) | (1 << WGM20);    
    TCCR2B = (1 << WGM22) | clockdivider ;  
    
    // Compare match Werte
    OCR2A = t_periode;
    OCR2B = t_pulse;
  }  
  
#endif  

#if (tim2_normalmode_enable == 1)

  void tim2_normal_init(uint8_t clockdivider)
  {
    // tim2 = normaler timer/counter  
    // Timermode benoetigt nur Divider, alle anderen Bits der Register
    // sind fuer Normalmode= 0
    TCCR2A = 0;
    TCCR2B = clockdivider;
    
    // Zaehlregister reset
    TCNT2= 0;
  }  

#endif

//----------------------------------------------------------------
//   und hier damit das als Gesamtes vorhanden ist.
int main(void)
{
  tim2_fastpwm_init(tim2_divisor128, 127, 63);
  while(1);
}
