/* -----------------------------------------------
                    serial_demo

     Demoprogramm fuer serielle Schnittstelle und
     einer "abgespeckten" printf-Version

     MCU : ATmega8, ATmega48/88/168/328p
     Takt: beliebig

     28.01.2020   R. Seelig

   ----------------------------------------------- */


#include <avr/io.h>
#include <string.h>

#include "my_printf.h"
#include "uart_all.h"

#define printf    my_printf
#define delay     _delay_ms

/* --------------------------------------------------------
   my_putchar

   wird von my-printf / printf aufgerufen und hier muss
   eine Zeichenausgabefunktion angegeben sein, auf das
   printf dann schreibt !
   -------------------------------------------------------- */
void my_putchar(char ch)
{
  uart_putchar(ch);
}


void searchreplace(char search, char replace, char *mytext)
{
  while(*mytext)
  {
    if (*mytext == search)      // bei Uebereinstimmung des Zeichens
    {
      *mytext = replace;        // an dieselbe Stelle das Ersatz-
    }                           // zeichen setzen
    mytext++;                   // naechstes Element
  }
}


/* --------------------------------------------------------
                             main
   -------------------------------------------------------- */
int main(void)
{
  uint8_t count;
  uint8_t ch;

  uart_init();

/*
  while(1)
  {
    ch= uart_getchar();
    printf("\n\r char: %x= %c",ch,ch);
  }
*/
  printf("\n\n\rRS-232 fuer ATmegaxx8\n\n\r");
  printf("Protokoll 8N1 %d0 Bd\n\n\r", BAUDRATE / 10);
  printf("Ein einfacher 16 Bit-Integer Zaehler\n\r");
  printf("------------------------------------\n\n\r");
  count= 0;

  while(1)
  {
    printf(" count= %d \r",count);
    count++;
    delay(1000);
  }
}
