/* -------------------------------------------------
                    tftmono_demo.c

   Testprogramm fuer monochrome, grafikfaehige
   Displays.

   Unterstuetzte Displays sind:

   - SSD1306 (I2C und SPI Interface)
   - PC8544 Displays (Nokia 5110 Display)

   MCU       :  ATmega8, ATmega48 .. ATmega328p
   Takt      :  nicht spezifiziert

   IDE       : keine (Editor / make)
   Toolchain : AVR-GCC

   07.05.19 by R. Seelig
  -------------------------------------------------- */

#include <avr/io.h>
#include <util/delay.h>
#include <avr/pgmspace.h>

#include "avr_gpio.h"

#include "tftmono.h"
#include "my_printf.h"

#include "female84.h"

#define  delay                _delay_ms
#define  printf               my_printf

/* --------------------------------------------------------
   putchar

   wird von my-printf / printf aufgerufen und hier muss
   eine Zeichenausgabefunktion angegeben sein, auf das
   printf dann schreibt !
   -------------------------------------------------------- */
void my_putchar(char ch)
{
  lcd_putchar(ch);
}

/* ------------------------------------------------------------------------
                                    MAIN
   ------------------------------------------------------------------------ */

int main(void)
{
  int i;

  lcd_init();
  lcd_enable();
  delay(150);

/*
  clrscr();
  i= 0;
  gotoxy(0,2); printf("Counter: ");
  while(1)
  {
    gotoxy(9,2);
    printf("%d   ",i);
    delay(500);
    i++;
  }
*/

  fb_init(84, 6);
  while(1)
  {

    clrscr();
    setfont(fnt8x8);
    gotoxy(1,1);
    printf("Mono-TFT\n\r");
    setfont(fnt5x7);
    delay(2000);
    clrscr();

    fb_clear();
    fb_outtextxy(1,22, 0, "Hallo Welt");

    fb_outtextxy(1,31, 0,"AVR-ATmega");

    fb_show((_xres/2)-42, 0);
    delay(2000);

    fb_clear();
    fillcircle(42,20, 17, 1);
    line(0,0, 83,39, 2);
    fb_show((_xres/2)-42, 0);
    delay(2000);

    clrscr();
    #if (ssd1306 == 1)
      showimage((_xres/2)-42, 2, &female84_image[0], 1);           // schwarzes Display, helle Schrift
    #else
      showimage((_xres/2)-42, 2, &female84_image[0], 2);           // helles Display, schwarze Schrift
    #endif
    delay(2000);

  }
}
