/* ------------------------------------------------
                    tftmono_demo32.c

   Testprogramm fuer monochrome, grafikfaehige
   Displays.

   Unterstuetzte Displays sind:

   - SSD1306 (I2C und SPI Interface)
   - PC8544 Displays (Nokia 5110 Display)

   MCU       :  ATmega8, ATmega48 .. ATmega328p
   Takt      :  nicht spezifiziert

   IDE       : keine (Editor / make)
   Toolchain : AVR-GCC

   07.04.22 by R. Seelig
  -------------------------------------------------- */

#include <stdlib.h>                             // fuer abs()

#include <avr/io.h>
#include <util/delay.h>
#include <avr/pgmspace.h>

#include "avr_gpio.h"

#include "tftmono.h"
#include "my_printf.h"

#include "girl2.h"

#define  delay                _delay_ms
#define  printf               my_printf


/* --------------------------------------------------------
   putchar

   wird von my-printf / printf aufgerufen und hier muss
   eine Zeichenausgabefunktion angegeben sein, auf das
   printf dann schreibt !
   -------------------------------------------------------- */
void my_putchar(char ch)
{
  lcd_putchar(ch);
}


/* ------------------------------------------------------------------------
                                    MAIN
   ------------------------------------------------------------------------ */

int main(void)
{
  int i;

  lcd_init();
  lcd_enable();
  clrscr();

  textsize= 0;

  fb_init(128, 4);
  while(1)
  {
    clrscr();
    setfont(fnt8x8);
    gotoxy(1,1);
    printf("Mono-TFT\n\r");
    setfont(fnt8x8);
    delay(2000);
    clrscr();
    gotoxy(4,0);
    printf("Countdown");
    textsize= 2;
    gotoxy(0,1);
    for (i= 100; i> 0; i--)
    {
      gotoxy(3,2);
      printf("%d  ",i);
      delay(100);
    }
    textsize= 0;
    clrscr();

    fb_clear();
    fb_outtextxy(1,5, 0, "Hallo Welt");
    fb_outtextxy(24,13, 0, "fuer");

    fb_outtextxy(17,25, 0,"ATmega");

    fb_show((_xres/2)-42, 0);
    delay(2000);

    fb_clear();
    fillcircle(64,20, 17, 1);
    line(0,0, 127,31, 2);
    fb_show(0, 0);
    delay(2000);

    clrscr();
    #if (ssd1306 == 1)
      showimage(0,0, &girl2_image[0], 1);           // schwarzes Display, helle Schrift
    #else
      showimage(0,0, &girl2_image[0], 2);           // helles Display, schwarze Schrift
    #endif
    delay(2000);

  }
}
